package it.unibo.stradivarius.tricksandthreats;

import android.content.Context;
import android.hardware.Sensor;
import android.hardware.SensorEvent;
import android.hardware.SensorEventListener;
import android.hardware.SensorManager;
import android.media.MediaPlayer;
import android.os.Bundle;
import android.widget.TextView;

import androidx.appcompat.app.AppCompatActivity;

import java.util.List;

public class SensorsActivity extends AppCompatActivity implements SensorEventListener {
    MediaPlayer mp;

    int counter = 0;
    SensorManager sm;

    Sensor sensorLight;
    Sensor sensorAcc;

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.sensors);

        sm = (SensorManager)getSystemService(Context.SENSOR_SERVICE);
        List<Sensor> ls = sm.getSensorList(Sensor.TYPE_ALL);
        TextView tv = findViewById(R.id.tv);

        sensorLight = sm.getDefaultSensor(Sensor.TYPE_LIGHT);
        sensorAcc = sm.getDefaultSensor(Sensor.TYPE_ACCELEROMETER);

        tv.setText("");

        mp = MediaPlayer.create(this, R.raw.electric);
        mp.setLooping(true);
        mp.start();

        for (int i = 0; i < ls.size(); i++) {
            tv.setText(tv.getText() + "\n" + ls.get(i).getName());
        }
    }

    @Override
    protected void onResume() {
        sm.registerListener(this, sensorLight, SensorManager.SENSOR_DELAY_NORMAL);
        sm.registerListener(this, sensorAcc, SensorManager.SENSOR_DELAY_NORMAL);
        super.onResume();
    }

    @Override
    protected void onPause() {
        sm.unregisterListener(this);
        super.onPause();
    }

    public void onAccuracyChanged(Sensor sensor, int accuracy) { /* So what? */ }

    public void onSensorChanged(SensorEvent event) {
        if (event.sensor.getType() == Sensor.TYPE_LIGHT) {
            TextView tv = findViewById(R.id.tvLight);
            tv.setText("Light: " + event.values[0]);

            counter = 0;
        } else if (event.sensor.getType() == Sensor.TYPE_ACCELEROMETER) {
            TextView tv = (TextView)findViewById(R.id.tvValues);
            tv.setText("Accell: " + event.values[0]);
            tv.setText(tv.getText() + "\nAccell: " + event.values[1]);
            tv.setText(tv.getText() + "\nAccell: " + event.values[2]);

            float value = (Math.min(event.values[0] / sm.getDefaultSensor(Sensor.TYPE_ACCELEROMETER).getMaximumRange(),1));
            mp.setVolume(value, value);
        }
    }
}
